# NOTE: Derived from blib/lib/Getopt/Long.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Getopt::Long;

#line 1211 "blib/lib/Getopt/Long.pm (autosplit into blib/lib/auto/Getopt/Long/configure.al)"
sub configure (@) {

    my $self = shift(@_);
    
    Croak (__PACKAGE__."::configure ".
	   "requires an object as its first argument\n")
      unless defined $self && index(ref($self), '=');

    print STDERR (__PACKAGE__." $Getopt::Long::VERSION ",
		  'configure $Revision: 2.24 $ ',
		  "called from package \"", $self->{_package}, "\".",
		  "\n  ",
		  "Config: (@_)",
		  "\n  ",
		  "autoabbrev=", $self->{autoabbrev}, ",".
		  "bundling=", $self->{bundling}, ",",
		  "getopt_compat=", $self->{getopt_compat}, ",",
		  "order=", $self->{order}, ",",
		  "\n  ",
		  "ignorecase=", $self->{ignorecase}, ",",
		  "passthrough=", $self->{passthrough}, ",",
		  "useprefix=", $self->{_useprefix}, ",",
		  "prefix=\"", $self->{_genprefix}, "\",",
		  "terminator=\"", $self->{_terminator}, "\".",
		  "\n")
	if $debug;

    # Copy config info to global variables.
    local $_genprefix         = $self->{_genprefix};
    local $_terminator        = $self->{_terminator};
    local $_useprefix         = $self->{_useprefix};
    local $autoabbrev         = $self->{autoabbrev};
    local $bundling           = $self->{bundling};
    local $debug              = $self->{debug};
    local $getopt_compat      = $self->{getopt_compat};
    local $ignorecase         = $self->{ignorecase};
    local $order              = $self->{order};
    local $passthrough        = $self->{passthrough};

    # Configure the global variables.
    Configure (@_);

    # If we have state, some configs may not change.
    if ( defined $self->{_state_} && 
	 ($self->{_genprefix}      ne $_genprefix ||
	  $self->{_useprefix}      != $_useprefix ||
	  $self->{autoabbrev}      != $autoabbrev ||
	  $self->{bundling}        != $bundling ||
	  $self->{getopt_compat}   != $getopt_compat ||
	  $self->{ignorecase}      != $ignorecase) ) {
	Croak (__PACKAGE__.": too late to configure\n");
    }

    # Copy config info from global variables.
    $self->{_genprefix}       = $_genprefix;
    $self->{_terminator}      = $_terminator;
    $self->{_useprefix}       = $_useprefix;
    $self->{autoabbrev}       = $autoabbrev;
    $self->{bundling}         = $bundling;
    $self->{getopt_compat}    = $getopt_compat;
    $self->{ignorecase}       = $ignorecase;
    $self->{debug}            = $debug;
    $self->{order}            = $order;
    $self->{passthrough}      = $passthrough;

    # Return self so calls can be chained.
    $self;
}

# end of Getopt::Long::configure
1;
