# NOTE: Derived from blib/lib/Getopt/Long.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Getopt::Long;

#line 952 "blib/lib/Getopt/Long.pm (autosplit into blib/lib/auto/Getopt/Long/valid.al)"
sub valid ($$$$) {
    my ($self, $opctl, $arg, $prefix) = @_;
    # Check if the argument is valid for this option.
    # Returns (found, the value, the rest of the arg, an error message)

    my $type = $opctl->[0];
    my $argreq = $opctl->[2] > 0;
    my $vlist = $opctl->[4];

    return (0, '', '', '') unless defined $arg;

    if ( $type eq "s" ) {	# string
	return (0, '', $arg, '') 
	  if !$argreq && 
	    $prefix ne '()' && $arg =~ /^$prefix/ &&
	      ($arg ne '-' || defined ($self->{_state_}->[0]->{""}));
	return (1, $arg, '', '') 
	  if !defined $vlist || scalar (grep {$_ eq $arg} @$vlist) > 0;
	return (0, '', $arg, 
		" (expecting " . join (" ", @$vlist) . ")");
    }

    if ( $type eq "n" || $type eq "i" ) { # numeric/integer
	if ( $arg =~ /^(-?[0-9]+)(.*)$/s ) {
	    return (1,$1,defined $+?$+:'','')
	      if !defined $vlist || scalar (grep {$_ == $1} @$vlist) > 0;
	    return (0, 0, $arg, 
		    " (expecting " . join (" ", @$vlist) . ")");
	}
	return (0, 0, $arg, " (number expected)");
    }

    if ( $type eq "f" ) { # real number, int is also ok
	# We require at least one digit before a point or 'e',
	# and at least one digit following the point and 'e'.
	# [-]NN[.NN][eNN]
	if ( $arg =~ /^(-?[0-9.]+(\.[0-9]+)?([eE]-?[0-9]+)?)(.*)$/s ) {
	    return (1,$1,defined $+?$+:'','')
	      if !defined $vlist || scalar (grep {$_ == $1} @$vlist) > 0;
	    return (0, 0, $arg, 
		    " (expecting " . join (" ", @$vlist) . ")");
	}
	elsif ( $arg =~ /^(-?[0-9]+)(.*)$/s ) {
	    return (1,$1,defined $+?$+:'','')
	      if !defined $vlist || scalar (grep {$_ == $1} @$vlist) > 0;
	    return (0, 0, $arg, 
		    " (expecting " . join (" ", @$vlist) . ")");
	}
	return (0, 0.0, $arg, " (real number expected)");
    }

    if ( $type eq 'r' ) {
	if ( $arg =~ /^(-?[0-9]+)(.*)$/s ) {
	    return (1,$1,defined $+?$+:'','')
	      if $1 >= $vlist->[0] && $1 <= $vlist->[1];
	    return (0, 0, $arg, " (number out of range " .
		    $vlist->[0] . " .. " . $vlist->[1] . ")");
	}
	return (0, 0, $arg, " (number expected)");
    }
    
    if ( $type eq 'b' ) {
	if ( $arg =~ /^(0*1|0x0*1|on|yes)(.*)$/is ) {
	    return (1, 1, defined $+?$+:'', '')
	      if !defined $vlist || 
		scalar (grep {lc($_) eq lc($1)} @$vlist) > 0;
	    return (0, 0, $arg, 
		    " (expecting " . join (" ", @$vlist) . ")");
	}
	if ( $arg =~ /^(0+|0x0+|off|no)(.*)$/is ) {
	    return (1, 0, defined $+?$+:'', '')
	      if !defined $vlist || 
		scalar (grep {lc($_) eq lc($1)} @$vlist) > 0;
	    return (0, 0, $arg, 
		    " (expecting " . join (" ", @$vlist) . ")");
	}
	return (0, 0, $arg, " (expecting 1 0 on off yes no)");
    }
    
    Croak (__PACKAGE__."::valid -- internal error!\n");
}

# end of Getopt::Long::valid
1;
